//  RW Dollhouse
// ==============
// Docking, Charging-System, Storage, and General Outboard Systems Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/dollhouse/dollhouse.hpp
// -Declarations of the baseline RW Dollhouse library

#pragma once

#include "incls_all.hpp"

namespace rw::dollhouse {

//------------------------------------------------------------------------------
/**
 */
class Dollhouse_b : public RW {
 public:
  Dollhouse_b();                                    // default ctor
  explicit Dollhouse_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Dollhouse : public Dollhouse_b {
 public:
  Dollhouse();                                    // default ctor
  explicit Dollhouse(std::string const& handle);  // tag-parm'd ctor

  // shell & power care
  void dock_me() {}
  void charge_me() {}
  void sleep_me() {}
  void wake_me() {}
  void store_me() {}

  inline auto electro() const -> Electro& { return electro_; }
  inline auto shell() const -> Shell& { return shell_; }

 private:
  unique_ptr<Electro_b> _electro_{make_unique<Electro_b>("dollhouse_electro")};
  unique_ptr<Shell_b>   _shell_{make_unique<Shell_b>("dollhouse_shell")};

  Electro& electro_{reference_to<Electro>(_electro_.get())};
  Shell&   shell_{reference_to<Shell>(_shell_.get())};
};

}  // namespace rw::dollhouse

//    --=^=--

// "______"

// rw_dollhouse_lib.v220226
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
