//  RW Greenlight
// ================
// ______
// -The RW Foundational Libraries

// Filename: ./include/rw/sys/greenlight.hpp
// -Declarations of the baseline RW Greenlight sysutil object

#pragma once

#include "incls_all.hpp"

namespace rw::sys {

//------------------------------------------------------------------------------
/** RW class objects that help afford queued 'any-to-any' communications for all
 * the important objects across the RW Foundations systems
 * @note: interfaces are set up thru static container members in derived classes
 */
struct Greenlight {
  // clang-format off

  Action_b       action{"greenlight_action"};
  Alexandria_b   alexandria{"greenlight_alexandria"};
  Analogy_b      analogy{"greenlight_analogy"};
  Animeyes_b     animeyes{"greenlight_animeyes"};
  Arigato_b      arigato{"greenlight_arigato"};
  Artstory_b     artstory{"greenlight_artstory"};
  Atashi_b       atashi{"greenlight_atashi"};
  Beauty_b       beauty{"greenlight_beauty"};
  Bones_b        bones{"greenlight_bones"};
  Bumpmaster_b   bumpmaster{"greenlight_bumpmaster"};
  Categories_b   categories{"greenlight_categories"};
  Chibitsu_b     chibitsu{"greenlight_chibitsu"};
  Cognate_b      cognate{"greenlight_cognate"};
  Collections_b  collections{"greenlight_collections"};
  Concept_b      concept {"greenlight_concept"};
  Curator_b      curator{"greenlight_curator"};
  Design_b       design{"greenlight_design"};
  Dogfood_b      dogfood{"greenlight_dogfood"};
  Dollhouse_b    dollhouse{"greenlight_dollhouse"};
  Electro_b      electro{"greenlight_electro"};
  Face_b         face{"greenlight_face"};
  Gears_b        gears{"greenlight_gears"};
  Graphicom_b    graphicom{"greenlight_graphicom"};
  Gymnasium_b    gymnasium{"greenlight_gymnasium"};
  Hand_b         hand{"greenlight_hand"};
  Hearsay_b      hearsay{"greenlight_hearsay"};
  Meido_b        meido{"greenlight_meido"};
  Mimicry_b      mimicry{"greenlight_mimicry"};
  Moveit_b       moveit{"greenlight_moveit"};
  Percept_b      percept{"greenlight_percept"};
  Scene_b        scene{"greenlight_scene"};
  Sempai_b       sempai{"greenlight_sempai"};
  Sensei_b       sensei{"greenlight_sensei"};
  Shell_b        shell{"greenlight_shell"};
  Terminal_b     terminal{"greenlight_terminal"};
  Waifusearch_b  waifusearch{"greenlight_waifusearch"};
  
  ///////
  // Dolldrop/Dollnet is meant for network-enabled RW projects only
  #if __has_include(<curl_easy.h>)
  
  Dolldrop_b     dolldrop{curator.t(), "greenlight_dolldrop"};  // a Curator 's
  
  #endif  // __has_include(<curl_easy.h>)

  // clang-format on

  //------------------------------------------------------------------------------
  /** Provides for an asynchronous, queued communications port with a @c
   * Greenlight base member object
   */
  struct Intersection {
    // TODO:
  };

  /**
   */
  void preflight_greenlight();  // TODO:
};

}  // namespace rw::sys

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v220226
// Copyright (2022)
// License MIT(Expat) https://opensource.org/licenses/MIT
